<template>
  <div>
    <!-- Loading dialog -->
    <v-dialog v-model="loading" hide-overlay persistent width="300">
      <v-card color="primary" dark>
        <v-card-text>Please stand by
          <v-progress-linear indeterminate color="white" class="mb-0"></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>

    <!-- Actual List -->
    <v-list two-line v-if="!loading">
      <template v-for="item in items">
        <component :is="itemComponent" :key="item.id" :id="`${item.id}`"/>
        <v-divider :key="`divider-${item.id}`"/>
      </template>
    </v-list>
  </div>
</template>
<script>
import gql from "graphql-tag";

export default {
  name: "gql-list-component",
  props: {
    queryName: { type: String, required: true },
    itemComponent: { type: String, required: true },
    emptyIcon: { type: String, default: "sentiment_very_dissatistifed" },
    emptyLabel: { type: String, default: "No entries were found" },
    emptyDescription: { type: String, default: null }
  },
  data() {
    return {
      items: [],
      loading: true,
      error: null
    };
  },
  apollo: {
    items: {
      pollInterval: 1000,
      query() {
        return gql`
          query {
            items: ${this.queryName} {
              id
            }
          }
        `;
      },
      result(result) {
        if (result.networkStatus === 8) {
          const error = result.error.networkError;

          if (error.statusCode) {
            const code = error.statusCode;

            this.error = {
              icon: "error_outline",
              label: "Error!",
              description:
                "We found an error! Please send an e-mail to our team so we can deal with it!"
            };
          } else {
            let icon = "signal_wifi_off";

            if (connection && connection.effectiveType === "cellular")
              icon = "signal_cellular_off";

            this.error = {
              icon: "signal_wifi_off",
              label: "Network Error",
              description:
                "Failed to connect to server. Please verify your internet connection."
            };
          }
        }
        this.loading = false;
      }
    }
  }
};
</script>
